#!/usr/bin/python


# Copyright (c) 1999-2002 Red Hat, Inc.  Distributed under GPL.
#
# Author: Adrian Likins <alikins@redhat.com>


# imports are a bit weird here to avoid name collions on "harware"
import sys
sys.path.append("/usr/share/rhn/")
from up2date_client import rollbacks
from up2date_client import configUtils
from up2date_client import config
argVerbose = 0

cfg = config.initUp2dateConfig()

__rhnexport__ = [
    'rollback',
    'listTransactions',
    'config',
    'undo' ]

_rollback = rollbacks.Rollback()

def listTransactions():
    data = {}
    data['version'] = "0"
    data['name'] = "rollback.listTransactions.data"

    dict = _rollback.getTransactionsData()
    data['transactions'] = dict
    return (0, "transaction info collected", data)

# resync hardware information with the server profile
def undo():
    data = _rollback.getUndoInfo()
    data['version'] = "0"
    data['name'] = "rollback.undo.rollback_info"
    _rollback.undo()

    return (0, "undo completed", data)

# pass in a string...
def config(value):
    cfg.set("enableRollbacks", value)
    cfg.save()
    # need to figure out what macro and macro values this is
    if value == "1":
        configUtils.writeUp2dateMacro("%_repackage_all_erasures", "1")
    if value == "0":
        configUtils.writeUp2dateMacro("%_repackage_all_erasures", "0")

    return (0, "config values updated", {})

        

def rollback(targettid, fromtid):
    try:
        data = _rollback.getTidInfo(targettid)
    except KeyError:
        data = {}
        data['version'] = "0"
        data['name'] = "rollback.rollback.invalid_tid"
        data['tid'] = targettid
        return (35, "Invalid transaction id", data)
    
    data['version'] = "0"
    data['name'] = "rollback.rollback.rollback_info"


    latesttid = _rollback.getLatestTid()

    # we are assuming these tid values are comparable
    # ints
    if int(latesttid) > int(fromtid):
        data['latesttid'] = latesttid
        data['currenttransactions'] = _rollback.getTransactionsData()
        return (36, "from tid is older than latest tid", data)
    
    _rollback.doRollback(targettid)
    return (0, "rollback completed", data)
    
def main():

    print config("0")
    
    sys.exit()
    print rollback(1029893837, 1029893623)
#    print "foo"

    latest = _rollback.getLatestTid()

    print _rollback.getTidInfo(1029893837)
    print rollback(1029893837, latest)

#    print undo()

    
#    print rollback(1029305278)
    

if __name__ == "__main__":
    main()
    
