#!/usr/bin/python
            
import rpm
import os   
import sys  
from rhpl.translate import _, N_
import up2dateErrors
import up2dateMessages
import rpmUtils
import up2dateAuth
import up2dateLog
import up2dateUtils
import rpcServer
import config
import transaction


log = up2dateLog.initLog()

try:
    from rhn import rpclib
except ImportError:
    rpclib = __import__("xmlrpclib")

cfg = config.initUp2dateConfig()


def getAdvisoryInfo(pkg, warningCallback=None):
    s = rpcServer.getServer()

    ts = transaction.initReadOnlyTransaction()
    # JBJ: FIXME: change dbMatch to return an iteratable value.
    mi = ts.dbMatch('Providename', pkg[0])
    if not mi:
	return None
    for h in mi:
       break

    try:
        pkgName = "%s-%s-%s" % (h['name'],
                                h['version'],
                                h['release'])
        log.log_me("getAdvisoryInfo for %s" % pkgName)
        info = rpcServer.doCall(s.errata.getPackageErratum,
                      up2dateAuth.getSystemId(),
                      pkg)
    except rpclib.Fault, f:
        if warningCallback:
            warningCallback(f.faultString)
        return None
    
    if info:
        return info
    
    try:
        log.log_me("getAdvisoryInfo for %s-0-0" % h['name'])
        info = rpcServer.doCall(s.errata.GetByPackage,
                      "%s-0-0" % h['name'],
                      up2dateUtils.getVersion())
    except rpclib.Fault, f:
        if warningCallback:
            warningCallback(f.faultString)
        return None
    
    return info
